---
title: Extra lives
slug: Games/Tutorials/2D_breakout_game_Phaser/Extra_lives
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
  - lives
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Win_the_game", "Games/Workflows/2D_Breakout_game_Phaser/Animations_and_tweens")}}</p>

<div class="summary">
<p>This is the <strong>13th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson13.html">Gamedev-Phaser-Content-Kit/demos/lesson13.html</a>.</p>
</div>

<p><span class="seoSummary">We can make the game enjoyable for longer by adding lives. In this article we'll implement a lives system, so that the player can continue playing until they have lost three lives, not just one.</span></p>

<h2 id="New_variables">New variables</h2>

<p>Add the following new variables below the existing ones in your code:</p>

<pre class="brush: js notranslate">var lives = 3;
var livesText;
var lifeLostText;
</pre>

<p>These respectively will store the number of lives, the text label that displays the number of lives that remain, and a text label that will be shown on screen when the player loses one of their lives.</p>

<h2 id="Defining_the_new_text_labels">Defining the new text labels</h2>

<p>Defining the texts look like something we already did in <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/The_score">the score</a> lesson. Add the following lines below the existing <code>scoreText</code> definition inside your <code>create()</code> function:</p>

<pre class="brush: js notranslate">livesText = game.add.text(game.world.width-5, 5, 'Lives: '+lives, { font: '18px Arial', fill: '#0095DD' });
livesText.anchor.set(1,0);
lifeLostText = game.add.text(game.world.width*0.5, game.world.height*0.5, 'Life lost, click to continue', { font: '18px Arial', fill: '#0095DD' });
lifeLostText.anchor.set(0.5);
lifeLostText.visible = false;
</pre>

<p>The <code>livesText</code> and <code>lifeLostText</code> objects look very similar to the <code>scoreText</code> one — they define a position on the screen, the actual text to display, and the font styling. The former is anchored on its top right edge to align properly with the screen, and the latter is centered, both using <code>anchor.set()</code>.</p>

<p>The <code>lifeLostText</code> will be shown only when the life is lost, so its visibility is initially set to <code>false</code>.</p>

<h3 id="Making_our_text_styling_DRY">Making our text styling DRY</h3>

<p>As you probably noticed we're using the same styling for all three texts: <code>scoreText</code>, <code>livesText</code> and <code>lifeLostText</code>. If we ever want to change the font size or color we will have to do it in multiple places. To make it easier for us to maintain in the future we can create a separate variable that will hold our styling, let's call it <code>textStyle</code> and place it before the text definitions:</p>

<pre class="brush: js notranslate">textStyle = { font: '18px Arial', fill: '#0095DD' };
</pre>

<p>We can now use this variable when stlying our text labels — update your code so that the multiple instances of the text styling are replaced with the variable:</p>

<pre class="brush: js notranslate">scoreText = game.add.text(5, 5, 'Points: 0', textStyle);
livesText = game.add.text(game.world.width-5, 5, 'Lives: '+lives, textStyle);
livesText.anchor.set(1,0);
lifeLostText = game.add.text(game.world.width*0.5, game.world.height*0.5, 'Life lost, click to continue', textStyle);
lifeLostText.anchor.set(0.5);
lifeLostText.visible = false;
</pre>

<p>This way changing the font in one variable will apply the changes to every place it is used.</p>

<h2 id="The_lives_handling_code">The lives handling code</h2>

<p>To implement lives in our game, let's first change the ball's function bound to the <code>onOutOfBounds</code> event. Instead of executing an anonymous function and showing the alert right away :</p>

<pre class="brush: js notranslate"><s>ball.events.onOutOfBounds.add(function(){
    alert('Game over!');
    location.reload();
}, this);</s>
</pre>

<p>We will assign a new function called <code>ballLeaveScreen</code>; delete the previous event handler (shown above) and replace it with the following line:</p>

<pre class="brush: js notranslate">ball.events.onOutOfBounds.add(ballLeaveScreen, this);
</pre>

<p>We want to decrease the number of lives every time the ball leaves the canvas. Add the <code>ballLeaveScreen()</code> function definition at the end of our code:</p>

<pre class="brush: js notranslate">function ballLeaveScreen() {
    lives--;
    if(lives) {
        livesText.setText('Lives: '+lives);
        lifeLostText.visible = true;
        ball.reset(game.world.width*0.5, game.world.height-25);
        paddle.reset(game.world.width*0.5, game.world.height-5);
        game.input.onDown.addOnce(function(){
            lifeLostText.visible = false;
            ball.body.velocity.set(150, -150);
        }, this);
    }
    else {
        alert('You lost, game over!');
        location.reload();
    }
}
</pre>

<p>Instead of instantly printing out the alert when you lose a life, we first subtract one life from the current number and check if it's a non-zero value. If yes, then the player still has some lives left and can continue to play — they will see the life lost message, the ball and paddle positions will be reset on screen and on the next input (click or touch) the message will be hidden and the ball will start to move again.</p>

<p>When the number of available lives reaches zero, the game is over and the game over alert message will be shown.</p>

<h2 id="Events">Events</h2>

<p>You have probably noticed the <code>add()</code> and <code>addOnce()</code> method calls in the above two code blocks and wondered how they differ. The difference is that the <code>add()</code> method binds the given function and causes it to be executed every time the event occurs, while <code>addOnce()</code> is useful when you want to have the bound function executed only once and then unbound so it is not executed again. In our case, on every <code>outOfBounds</code> event the <code>ballLeaveScreen</code> will be executed, but when the ball leaves the screen we only want to remove the message from the screen once.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/yk1c5n0b/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Lives made the game more forgiving — if you lose one life, you still have two more left and can continue to play. Now let's expand the look and feel of the game by adding <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Animations_and_tweens">animations and tweens</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Win_the_game", "Games/Workflows/2D_Breakout_game_Phaser/Animations_and_tweens")}}</p>
